/*--------------------------------------------------------------------------*\
 |                                                                          |
 |  Copyright (C) 2003-2010                                                 |
 |                                                                          |
 |         , __                 , __                                        |
 |        /|/  \               /|/  \                                       |
 |         | __/ _   ,_         | __/ _   ,_                                | 
 |         |   \|/  /  |  |   | |   \|/  /  |  |   |                        |
 |         |(__/|__/   |_/ \_/|/|(__/|__/   |_/ \_/|/                       |
 |                           /|                   /|                        |
 |                           \|                   \|                        |
 |                                                                          |
 |      Enrico Bertolazzi                                                   |
 |      Dipartimento di Ingegneria Meccanica e Strutturale                  |
 |      Universita` degli Studi di Trento                                   |
 |      Via Mesiano 77, I-38050 Trento, Italy                               |
 |      email: enrico.bertolazzi@unitn.it                                   |
 |                                                                          |
\*--------------------------------------------------------------------------*/

#ifndef MALLOC_HH
#define MALLOC_HH

#include <string>

/*
//   __  __       _ _            
//  |  \/  | __ _| | | ___   ___ 
//  | |\/| |/ _` | | |/ _ \ / __|
//  | |  | | (_| | | | (_) | (__ 
//  |_|  |_|\__,_|_|_|\___/ \___|
*/

template <typename T>
class Malloc {
  typedef T                 valueType           ;
  typedef valueType*        valuePointer        ;  
  typedef const valueType*  valueConstPointer   ; 
  typedef valueType&        valueReference      ;
  typedef const valueType&  valueConstReference ;

  typedef long              indexType           ;
  typedef indexType*        indexPointer        ;  
  typedef const indexType*  indexConstPointer   ; 
  typedef indexType&        indexReference      ;
  typedef const indexType&  indexConstReference ;

private:

  std::string  theName ;
  indexType    numTotValues ;
  indexType    numTotReserved ;
  indexType    numAllocated ;
  valuePointer pMalloc ;

  Malloc(Malloc<T> const &) ;
  Malloc<T> const & operator = (Malloc<T> &) const ;

public:

  explicit Malloc( std::string const & _name ) ;    
  ~Malloc() ;

  void allocate( indexType n ) ;
  void free(void) ;

  indexType size(void) const { return numTotValues ; }
  T * operator () ( indexType sz ) ;
} ;

#endif
